<script setup lang="ts">
import { computed, onMounted, reactive, ref } from 'vue'

import type { VForm } from 'vuetify/components';
import CheckInOutTable from './CheckInOutTable.vue';
import { useSalaryStore } from '@/stores/salary'
import { useBranchStore } from '@/stores/branch';
import { useAuthStore } from '@/stores/auth';
import { useLoadingStore } from '@/stores/loading';
import { useUserStore } from '@/stores/user';
import PaymentSlip from './PaymentSlip.vue';

const branchStore = useBranchStore()
const salaryStore = useSalaryStore()
const authStore = useAuthStore()
const userStore = useUserStore()

const selectedBranchId = ref(null)
const selectedMonth = ref(null) // Reactive variable to store the selected month
const currentUser = authStore.getCurrentUser()
const Currentrole = authStore.getCurrentUser()!.role.name

const filteredSalarys = computed(() => {
  if (!currentUser) return []

  // เจ้าของกิจการดูข้อมูลทั้งหมด
  if (Currentrole === 'เจ้าของกิจการ') {
    if (!selectedBranchId.value && !selectedMonth.value) { // เพิ่มเงื่อนไขเช็คว่าไม่ได้เลือกสาขาและเดือน
      return salaryStore.salarys.value.filter((item) => {
        return item.status === 'not pay'; // กรองข้อมูลที่มี status เป็น 'not pay' เท่านั้น
      });
    } else if (!selectedBranchId.value) {
      return salaryStore.salarys.value.filter((item) => {
        return item.status === 'not pay' && item.month === selectedMonth.value; // กรองด้วยเดือนที่เลือกเท่านั้น
      });
    } else if (!selectedMonth.value) {
      return salaryStore.salarys.value.filter((item) => {
        return item.branch === selectedBranchId.value?.id && item.status === 'not pay'; // กรองด้วยสาขาที่เลือกเท่านั้น
      });
    } else {
      return salaryStore.salarys.value.filter((item) => {
        return item.branch === selectedBranchId.value?.id && item.status === 'not pay' && item.month === selectedMonth.value; // กรองด้วยสาขาและเดือนที่เลือกเท่านั้น
      });
    }
  }

  // ผู้จัดการร้านดูข้อมูลของ branch เฉพาะ
  if (Currentrole === 'ผู้จัดการร้าน') {
    if (!selectedBranchId.value && !selectedMonth.value) {
      return salaryStore.salarys.value.filter((item) => {
        return item.status === 'not pay' && item.branch === currentUser.branch;
      });
    } else if (!selectedBranchId.value) {
      return salaryStore.salarys.value.filter((item) => {
        return item.status === 'not pay' && item.branch === currentUser.branch && item.month === selectedMonth.value;
      });
    } else if (!selectedMonth.value) {
      return salaryStore.salarys.value.filter((item) => {
        return item.status === 'not pay' && item.branch === selectedBranchId.value?.id;
      });
    } else {
      return salaryStore.salarys.value.filter((item) => {
        return item.branch === selectedBranchId.value?.id && item.status === 'not pay' && item.month === selectedMonth.value;
      });
    }
  }

  // พนักงานพาทไทม์และพนักงานทั่วไปดูข้อมูลของตัวเองเท่านั้น
  if (Currentrole === 'พนักงานพาทไทม์' || Currentrole === 'พนักงานทั่วไป') {
    return salaryStore.salarys.value.filter((item) => {
      return item.user === currentUser.id && item.status === 'not pay';
    });
  }

  return [] // คืนค่าข้อมูลว่างๆ ในกรณีที่ไม่ตรงกับเงื่อนไขใดๆ
});

// ปิดการใช้งานปุ่ม Pay สำหรับผู้ใช้ที่มี Role เป็น "พนักงานพาทไทม์" หรือ "พนักงานทั่วไป"
const disablePayButton = computed(() => {
  return Currentrole === 'พนักงานพาทไทม์' || Currentrole === 'พนักงานทั่วไป'
})

function formatDate(date: any) {
  if (!date) return ''; // Return empty string if date is not provided
  return new Date(date).toLocaleDateString();
}

onMounted(async () => {
  await branchStore.getBranches()
  await salaryStore.getSalarys()
  await userStore.getUsers()
})
</script>

<template>
  <div>
    <v-sheet>
      <v-container fluid>
        <v-row>
          <v-col cols="12" sm="12">
            <v-card class="mx-auto">
              <!-- <v-card-title>Salary Management</v-card-title> -->
              <v-toolbar flat>
                <v-toolbar-title>Salary Management</v-toolbar-title>
                <v-divider class="mx-4" inset vertical></v-divider>
                <v-spacer></v-spacer>
              </v-toolbar>

              <v-row>
                <v-card-text style="max-height: 100px" class="mt-4 mr-2 ml-2">
                  <v-row>
                    <v-col cols="12" md="4">
                      <v-select v-if="Currentrole === 'เจ้าของกิจการ'" v-model="selectedBranchId"
                        :items="branchStore.branches" item-title="name" item-value="id" return-object clearable
                        density="compact" placeholder="เลือกสาขา" prepend-inner-icon="mdi-awning-outline"
                        variant="outlined" filled rounded bg-color="#ffcb5e"></v-select>
                    </v-col>
                    <v-col cols="12" sm="4">
                      <v-select v-model="selectedMonth" :items="[1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12]" return-object
                        clearable dense placeholder="เลือกเดือน" density="compact"
                        prepend-inner-icon="mdi-calendar-month" variant="outlined" filled rounded>
                      </v-select>
                    </v-col>
                  </v-row>
                </v-card-text>
              </v-row>

              <v-table fixed-header height="530">
                <thead>
                  <tr>
                    <th>Id</th>
                    <th>ชื่อ-นามสกุล</th>
                    <th>ตำแหน่ง</th>
                    <th>รอบเดือน</th>
                    <th>ฐานเงินเดือน</th>
                    <th>จำนวนชั่วโมงรวม</th>
                    <th>จำนวนเงินรวม</th>
                    <th>สถานะ</th>
                    <th>จ่ายเงิน</th>
                  </tr>
                </thead>
                <tbody>
                  <tr v-for="item in filteredSalarys" :key="item.id">
                    <td>{{ item.id }}</td>
                    <td>{{ item.fullName }}</td>
                    <td>{{ item.role }}</td>
                    <td>{{ item.month }}</td>
                    <td>{{ item.pricePerHour }}</td>
                    <td>{{ item.totalHour }}</td>
                    <td>{{ item.totalPay }}</td>
                    <td>{{ item.status }}</td>
                    <td>
                      <!-- ปุ่ม Pay ที่ถูกปิดการใช้งานสำหรับบาง Role -->
                      <v-btn v-if="!disablePayButton" size="30px" prepend-icon="mdi-currency-usd"
                        @click="salaryStore.showPayroll(item)"></v-btn>
                      <v-btn v-else disabled size="30px" prepend-icon="mdi-currency-usd"
                        @click="salaryStore.showPayroll(item)"></v-btn>
                    </td>
                  </tr>
                </tbody>
              </v-table>


              <v-dialog v-model="salaryStore.PaymentDialog.value" persistent :max-width="'1200px'">
                <v-container>
                  <v-card class="px-10 py-8">
                    <v-row>
                      <v-col cols="12" md="8">
                        <v-row>
                          <v-col cols="12" md="12">
                            <h1 class="headline mb-2 grey--text">Payment</h1>
                          </v-col>
                          <v-col cols="12" md="4" sm="4">
                            <v-card>
                              <v-list-item prepend-icon="mdi-clock">
                                <v-list-item-content>
                                  <v-list-item-subtitle>Total Work Hour </v-list-item-subtitle>
                                  <v-list-item-title>{{ salaryStore.selected.value.totalHour }}</v-list-item-title>
                                </v-list-item-content>
                              </v-list-item>
                            </v-card>
                          </v-col>

                          <!-- PAy Rate -->
                          <v-col cols="12" md="4" sm="4">
                            <v-card>
                              <v-list-item prepend-icon="mdi-cash">
                                <v-list-item-content>
                                  <v-list-item-subtitle>Rate</v-list-item-subtitle>
                                  <v-list-item-title>{{ salaryStore.selected.value.pricePerHour }}</v-list-item-title>
                                </v-list-item-content>
                              </v-list-item>
                            </v-card>
                          </v-col>


                          <!-- กล่องบน กลาง จำนวนจ่ายรวม -->
                          <v-col cols="12" md="4" sm="4">
                            <v-card>
                              <v-list-item prepend-icon="mdi-currency-usd">
                                <v-list-item-content>
                                  <v-list-item-subtitle>Total Pay</v-list-item-subtitle>
                                  <v-list-item-title>{{ salaryStore.selected.value.totalPay }}</v-list-item-title>
                                </v-list-item-content>
                              </v-list-item>
                            </v-card>
                          </v-col>

                          <!-- <v-col cols="12" md="12">
                            <h1 class="headline mb-2 grey--text">Check In- Out </h1>
                          </v-col>
                          <v-col cols="12" md="12">
                            <v-card>

                              <CheckInOutTable></CheckInOutTable>

                            </v-card>
                          </v-col> -->
                        </v-row>
                      </v-col>

                      <!-- Profile -->
                      <v-col cols="12" md="4">
                        <v-row>
                          <v-col cols="12" md="12">
                            <h1 class="headline mb-2 grey--text">Profile</h1>
                          </v-col>

                          <!-- <v-col cols="12" md="12" sm="12">
                            <v-card>
                              <v-avatar class="mt-5" rounded="100" size="48">
                                <v-img :src="getUserAvatar() " cover></v-img>
                              </v-avatar>
                            
                            </v-card>
                          </v-col> -->

                          <v-col cols="12" md="12" sm="12">
                            <v-card>
                              <v-list-item prepend-icon="mdi-account">
                                <v-list-item-content>
                                  <v-list-item-subtitle>ชื่อ-นามสกุล</v-list-item-subtitle>
                                  <v-list-item-title>{{ salaryStore.selected.value.fullName }}</v-list-item-title>
                                </v-list-item-content>
                              </v-list-item>
                            </v-card>
                          </v-col>

                          <v-col cols="12" md="12" sm="12">
                            <v-card>
                              <v-list-item prepend-icon="mdi-clipboard-account">
                                <v-list-item-content>
                                  <v-list-item-subtitle>ตำแหน่ง</v-list-item-subtitle>
                                  <v-list-item-title>{{ salaryStore.selected.value.role }}</v-list-item-title>
                                </v-list-item-content>
                              </v-list-item>
                            </v-card>
                          </v-col>

                          <v-col cols="12" md="12" sm="12">
                            <v-card>
                              <v-list-item prepend-icon="mdi-awning-outline">
                                <v-list-item-content>
                                  <v-list-item-subtitle>สาขา</v-list-item-subtitle>
                                  <v-list-item-title>{{ salaryStore.selected.value.branch }}</v-list-item-title>
                                </v-list-item-content>
                              </v-list-item>
                            </v-card>
                          </v-col>
                          <!-- <v-divider></v-divider> -->
                        </v-row>
                      </v-col>
                    </v-row>

                    <v-card-actions class="mt-6">
                      <v-spacer></v-spacer>
                      <v-btn variant="text" @click="salaryStore.PaymentDialog.value = false"> Close </v-btn>
                      <v-btn variant="text" class="mr-0 mb-0" @click="() => {
                  ; (salaryStore.SlipDialog.value = true)
                    ,
                    (salaryStore.PaymentDialog.value = false)
                }">
                        Payment
                      </v-btn>
                    </v-card-actions>
                  </v-card>
                </v-container>
              </v-dialog>

              <!-- Slip -->
              <v-dialog v-model="salaryStore.SlipDialog.value" persistent width="500">
                <v-card class="d-flex align-center justify-center">
                  <v-img src="./img/logo/logo_name_black.png" alt="Logo" width="120px" class="text-center mt-3"></v-img>

                  <v-card-title style="text-align: center; font-size: 20px"><strong>PAY SLIP</strong>
                  </v-card-title>

                  <v-card-text class="info" style="text-align: center; margin-top: 0; padding-top: 5; line-height: 0">
                    ****************************************************************
                  </v-card-text>
                  <v-card-text>
                    <v-row class="info">
                      <v-col style="text-align: center">
                        <v-row>
                          <v-col>Payment ID : {{ salaryStore.selected.value.id }}</v-col>
                        </v-row>
                        <v-row>
                          <v-col>Full Name : {{ salaryStore.selected.value.fullName }}</v-col>
                        </v-row>
                        <v-row>
                          <v-col>Position : {{ salaryStore.selected.value.role }}</v-col>
                        </v-row>
                      </v-col>
                    </v-row>
                    <v-card-text class="info" style="text-align: center; margin-top: 0; padding-top: 5; line-height: 0">
                      ***************************************************************************
                    </v-card-text>
                    <h3 style="text-align: center;"> เงินเดือน </h3>
                    <v-card-text>
                      <v-row style="padding-bottom: 0; text-align: center">
                        <v-col> ฐานเงินเดือน </v-col>
                        <v-col> ชั่วโมงรวมสุทธิ </v-col>
                        <v-col> จำนวนเงินรวม </v-col>
                      </v-row>
                      <v-row style="padding-bottom: 0; text-align: center">
                        <v-col>{{ salaryStore.selected.value.pricePerHour }}</v-col>
                        <v-col>{{ salaryStore.selected.value.totalHour }}</v-col>
                        <v-col>{{ salaryStore.selected.value.totalPay }}</v-col>
                      </v-row>
                    </v-card-text>
                    <v-card-text class="info" style="text-align: center; margin-top: 0; padding-top: 5; line-height: 0">
                      ***************************************************************************
                    </v-card-text>

                    <v-card-text>
                      <v-row>
                        <v-col cols="12" md="12">
                          <v-row>
                            <v-col cols="12" md="6" style="text-align: left" class="info">Pay Date : {{
                  formatDate(salaryStore.selected.value.payDate)
                }}</v-col>
                            <v-col cols="12" md="6" style="text-align: right" class="info">Payer's Name : {{
                    authStore.getCurrentUser()?.name
                  }}</v-col>
                          </v-row>
                        </v-col>
                      </v-row>
                    </v-card-text>
                  </v-card-text>

                  <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn style="background-color: transparent" variant="text"
                      @click="salaryStore.SlipDialog.value = false">
                      Close
                    </v-btn>
                    <v-btn style="background-color: transparent" variant="text" @click="() => {
                  salaryStore.confirmPayment()
                  salaryStore.SlipDialog.value = false
                }
                  ">
                      Confirm
                    </v-btn>
                  </v-card-actions>
                </v-card>
              </v-dialog>

            </v-card>
          </v-col>
        </v-row>
      </v-container>
    </v-sheet>
  </div>
</template>

<style scoped>
.v-sheet {
  background-color: #fff5e8;
}

.v-sheet,
.v-card {
  border-bottom-left-radius: 15px;
  border-bottom-right-radius: 15px;
  border-top-left-radius: 15px;
  border-top-right-radius: 15px;
  text-decoration: none;
}

.v-toolbar {
  border-top-left-radius: 15px;
  border-top-right-radius: 15px;
  text-decoration: none;
  background-color: #ab9283;
}

.v-toolbar-title {
  font-weight: bold;
  font-size: 24px;
  color: white;
}

.v-table {
  border-bottom-left-radius: 15px;
  border-bottom-right-radius: 15px;
  text-decoration: none;
  background-color: #fff5e8;
}

.v-btn {
  background-color: #ffcb5e;
  border-radius: 30px;
  padding: 8px 16px;
}

.info {
  font-size: 14px;
}
</style>
